gtkmm: Gtk::Popover Class Reference

gtkmm 4.0.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::Popover Class Reference
Widgets

Context dependent bubbles. More...

`#include <gtkmm/popover.h>`

Inheritance diagram for Gtk::Popover:
[legend]

## Public Member Functions
| Popover (Popover&& src) noexcept
Popover& | operator= (Popover&& src) noexcept
| Popover (const Popover&)=delete
Popover& | operator= (const Popover&)=delete
| ~Popover () noexcept override
GtkPopover* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkPopover* | gobj () const
| Provides access to the underlying C GObject. More...
| Popover ()
void | set_child (Widget& child)
| Sets the child widget of popover. More...
void | unset_child ()
Widget* | get_child ()
| Gets the child widget of popover. More...
const Widget* | get_child () const
| Gets the child widget of popover. More...
void | set_pointing_to (const Gdk::Rectangle& rect)
| Sets the rectangle that popover will point to, in the coordinate space of the popover parent. More...
bool | get_pointing_to (Gdk::Rectangle& rect) const
| If a rectangle to point to has been set, this function will return `true` and fill in rect with such rectangle, otherwise it will return `false` and fill in rect with the attached widget coordinates. More...
void | set_position (PositionType position=PositionType::TOP)
| Sets the preferred position for popover to appear. More...
PositionType | get_position () const
| Returns the preferred position of popover. More...
void | set_autohide (bool autohide=true)
| Sets whether popover is modal. More...
bool | get_autohide () const
| Returns whether the popover is modal. More...
void | set_has_arrow (bool has_arrow=true)
| Sets whether this popover should draw an arrow pointing at the widget it is relative to. More...
bool | get_has_arrow () const
| Gets whether this popover is showing an arrow pointing at the widget that it is relative to. More...
void | set_mnemonics_visible (bool mnemonics_visible=true)
| Sets the Gtk::Popover::property_mnemonics_visible() property. More...
bool | get_mnemonics_visible () const
| Gets the value of the Gtk::Popover::property_mnemonics_visible() property. More...
void | popup ()
| Pops popover up. More...
void | popdown ()
| Pops popover down.This is different than a Gtk::Widget::hide() call in that it shows the popover with a transition. More...
void | set_offset (int x_offset, int y_offset)
| Sets the offset to use when calculating the position of the popover. More...
void | get_offset (int& x_offset, int& y_offset) const
| Gets the offset previous set with set_offset(). More...
void | set_cascade_popdown (bool cascade_popdown=true)
| If cascade_popdown is #`true`, the popover will be closed when a child modal popover is closed. More...
bool | get_cascade_popdown () const
| Returns whether the popover will close after a modal child is closed. More...
void | set_default_widget (Widget& widget)
| The default widget is the widget that’s activated when the user presses Enter in a dialog (for example). More...
void | present ()
| Presents the popover to the user. More...
Glib::PropertyProxy< Gdk::Rectangle > | property_pointing_to ()
| Rectangle the bubble window points to. More...
Glib::PropertyProxy_ReadOnly< Gdk::Rectangle > | property_pointing_to () const
| Rectangle the bubble window points to. More...
Glib::PropertyProxy< PositionType > | property_position ()
| Position to place the bubble window. More...
Glib::PropertyProxy_ReadOnly< PositionType > | property_position () const
| Position to place the bubble window. More...
Glib::PropertyProxy< bool > | property_autohide ()
| Whether to dismiss the popover on outside clicks. More...
Glib::PropertyProxy_ReadOnly< bool > | property_autohide () const
| Whether to dismiss the popover on outside clicks. More...
Glib::PropertyProxy< bool > | property_has_arrow ()
| Whether to draw an arrow. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_arrow () const
| Whether to draw an arrow. More...
Glib::PropertyProxy< Widget* > | property_default_widget ()
| The default widget. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_default_widget () const
| The default widget. More...
Glib::PropertyProxy< bool > | property_mnemonics_visible ()
| Whether mnemonics are currently visible in this popover. More...
Glib::PropertyProxy_ReadOnly< bool > | property_mnemonics_visible () const
| Whether mnemonics are currently visible in this popover. More...
Glib::PropertyProxy< Widget* > | property_child ()
| The child widget. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_child () const
| The child widget. More...
Glib::PropertyProxy< bool > | property_cascade_popdown ()
| Whether the popover pops down after a child popover. More...
Glib::PropertyProxy_ReadOnly< bool > | property_cascade_popdown () const
| Whether the popover pops down after a child popover. More...
Glib::SignalProxy< void()> | signal_closed ()
Public Member Functions inherited from Gtk::Widget
| Widget (Widget&& src) noexcept
Widget& | operator= (Widget&& src) noexcept
| Widget (const Widget&)=delete
Widget& | operator= (const Widget&)=delete
| ~Widget () noexcept override
| Destroys the widget. More...
GtkWidget* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget. More...
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget. More...
void | show ()
| Flags a widget to be displayed. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | queue_draw ()
| Schedules this widget to be redrawn in paint phase of the current or the next frame. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
void | queue_allocate ()
| This function is only for use in widget implementations. More...
void | size_allocate (const Allocation& allocation, int baseline)
| This is a simple form of allocate() that takes the new position of widget as part of allocation. More...
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout. More...
void | measure (Orientation orientation, int for_size, int& minimum, int& natural, int& minimum_baseline, int& natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size. More...
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management. More...
void | set_layout_manager (const Glib::RefPtr< LayoutManager >& layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget. More...
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager(). More...
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager set using set_layout_manager(). More...
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager set using set_layout_manager(). More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them. More...
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children. More...
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children. More...
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus. More...
bool | get_focusable () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus. More...
bool | grab_focus ()
| Causes widget (or one of its descendents) to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse. More...
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse. More...
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events. More...
bool | get_can_target () const
| Queries whether widget can be the target of pointer events. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations. More...
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations. More...
StateFlags | get_state_flags () const
| Returns the widget state as a flag set. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget’s sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget’s effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible. More...
bool | is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget. More...
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget. More...
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget. More...
Allocation | get_allocation () const
| Retrieves the widget’s location. More...
int | get_width () const
| Returns the content width of the widget, as passed to its size-allocate implementation. More...
int | get_height () const
| Returns the content height of the widget, as passed to its size-allocate implementation. More...
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget, depending on orientation. More...
Widget* | get_parent ()
| Returns the parent widget of widget. More...
const Widget* | get_parent () const
| Returns the parent widget of widget. More...
Root* | get_root ()
| Returns the Gtk::Root widget of widget or `nullptr` if the widget is not contained inside a widget tree with a root widget. More...
const Root* | get_root () const
| Returns the Gtk::Root widget of widget or `nullptr` if the widget is not contained inside a widget tree with a root widget. More...
Native* | get_native ()
| Returns the GtkNative widget that contains widget, or `nullptr` if the widget is not contained inside a widget tree with a native ancestor. More...
const Native* | get_native () const
| Returns the GtkNative widget that contains widget, or `nullptr` if the widget is not contained inside a widget tree with a native ancestor. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you’d use grab_focus() to move the focus to a particular widget. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget’s size request will be at least width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent, with opacity 0 being fully transparent and 1 fully opaque. More...
double | get_opacity () const
| Fetches the requested opacity for this widget. More...
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area. More...
Overflow | get_overflow () const
| Returns the value set via set_overflow(). More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget. More...
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| This is a utility function to get the clipboard object for the Gdk::Display that widget is using. More...
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| This is a utility function to get the clipboard object for the Gdk::Display that widget is using. More...
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| This is a utility function to get the primary clipboard object for the Gdk::Display that widget is using. More...
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| This is a utility function to get the primary clipboard object for the Gdk::Display that widget is using. More...
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space. More...
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space. More...
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used. More...
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space. More...
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space. More...
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used. More...
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible. More...
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions. More...
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property. More...
void | set_halign (Align align)
| Sets the horizontal alignment of widget. More...
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property. More...
void | set_valign (Align align)
| Sets the vertical alignment of widget. More...
int | get_margin_start () const
| Gets the value of the Gtk::Widget::property_margin_start() property. More...
void | set_margin_start (int margin)
| Sets the start margin of widget. More...
int | get_margin_end () const
| Gets the value of the Gtk::Widget::property_margin_end() property. More...
void | set_margin_end (int margin)
| Sets the end margin of widget. More...
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property. More...
void | set_margin_top (int margin)
| Sets the top margin of widget. More...
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property. More...
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget. More...
void | set_margin (int margin)
| Set all 4 margins to the same value. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, double src_x, double src_y, double& dest_x, double& dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations. More...
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget. More...
Widget* | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget (including widget itself) closest to the screen at the point ( x, y). More...
const Widget* | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget (including widget itself) closest to the screen at the point ( x, y). More...
void | add_controller (const Glib::RefPtr< EventController >& controller)
| Adds controller to widget so that it will receive events. More...
void | remove_controller (const Glib::RefPtr< EventController >& controller)
| Removes controller from widget, so that it doesn't process events anymore. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font options, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
void | set_font_options (const Cairo::FontOptions& options)
| Sets the #cairo_font_options_t used for Pango rendering in this widget. More...
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options(). More...
Cairo::FontOptions | get_font_options () const
| Returns the #cairo_font_options_t used for Pango rendering. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | set_cursor (const Glib::RefPtr< Gdk::Cursor >& cursor)
| Sets the cursor to be shown when pointer devices point towards widget. More...
void | set_cursor (const Glib::ustring& name={})
| Sets a named cursor to be shown when pointer devices point towards the widget. More...
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set via set_cursor(). More...
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set via set_cursor(). More...
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a mouse drag starting at ( start_x, start_y) and ending at ( current_x, current_y) has passed the GTK drag threshold, and thus should trigger the beginning of a drag-and-drop operation. More...
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget. More...
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Widget. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget set using set_tooltip_markup(). More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
bool | in_destruction () const
| Returns whether the widget is currently being destroyed. More...
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget. More...
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget. More...
guint | add_tick_callback (const SlotTick& slot)
| Queues an animation frame update and adds a callback to be called before each frame. More...
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback(). More...
void | insert_action_group (const Glib::ustring& name, const Glib::RefPtr< Gio::ActionGroup >& group)
| Inserts group into widget. More...
void | remove_action_group (const Glib::ustring& name)
| Removes a group from the widget. More...
bool | activate_action (const Glib::ustring& name, const Glib::VariantBase& args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it. More...
void | activate_default ()
| Activate the default.activate action from widget. More...
void | set_font_map (const Glib::RefPtr< Pango::FontMap >& font_map)
| Sets the font map to use for Pango rendering. More...
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map that has been set with set_font_map(). More...
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map that has been set with set_font_map(). More...
Widget* | get_first_child ()
| Returns the widgets first child. More...
const Widget* | get_first_child () const
| Returns the widgets first child. More...
Widget* | get_last_child ()
| Returns the widgets last child. More...
const Widget* | get_last_child () const
| Returns the widgets last child. More...
Widget* | get_next_sibling ()
| Returns the widgets next sibling. More...
const Widget* | get_next_sibling () const
| Returns the widgets next sibling. More...
Widget* | get_prev_sibling ()
| Returns the widgets previous sibling. More...
const Widget* | get_prev_sibling () const
| Returns the widgets previous sibling. More...
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a ListModel to track the children of widget. More...
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a ListModel to track the children of widget. More...
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a ListModel to track the Gtk::EventControllers of widget. More...
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a ListModel to track the Gtk::EventControllers of widget. More...
void | insert_after (Widget& parent, const Widget& previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling. More...
void | insert_before (Widget& parent, const Widget& next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling. More...
void | insert_at_start (Widget& parent)
| Inserts the Widget at the beginning of the child widget list of parent. More...
void | insert_at_end (Widget& parent)
| Inserts the Widget at the end of the child widget list of parent. More...
void | snapshot_child (Widget& child, const Glib::RefPtr< Gtk::Snapshot >& snapshot)
| When a widget receives a call to the snapshot function, it must send synthetic Gtk::WidgetClass.snapshot() calls to all children. More...
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent. More...
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self. More...
void | add_css_class (const Glib::ustring& css_class)
| Adds css_class to widget. More...
void | remove_css_class (const Glib::ustring& css_class)
| Removes css_class from widget. More...
bool | has_css_class (const Glib::ustring& css_class) const
| Returns whether css_class is currently applied to widget. More...
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of css classes applied to widget. More...
void | set_css_classes (const std::vector< Glib::ustring >& classes)
| Will clear all css classes applied to widget and replace them with classes. More...
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip >&)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Widget* > | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Root* > | property_root () const
| The Gtk::Root widget of the widget tree containing this widget or `nullptr` if the widget is not contained in a root widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events. More...
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat]. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat]. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget. More...
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget. More...
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally. More...
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the Gtk::Widget::property_hexpand() property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the Gtk::Widget::property_hexpand() property. More...
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically. More...
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the Gtk::Widget::property_vexpand() property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the Gtk::Widget::property_vexpand() property. More...
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget. More...
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated. More...
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated. More...
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree. More...
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget. More...
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget. More...
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The Gtk::LayoutManager instance to use to compute the preferred size of the widget, and allocate its children. More...
Public Member Functions inherited from Gtk::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible&& src) noexcept
Accessible& | operator= (Accessible&& src) noexcept
| ~Accessible () noexcept override
GtkAccessible* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkAccessible* | gobj () const
| Provides access to the underlying C GObject. More...
Role | get_accessible_role () const
| Retrieves the Gtk::Accessible::Role for the given Gtk::Accessible. More...
void | update_state (State state, const Glib::ValueBase& value)
| Updates an accessible state. More...
void | update_property (Property property, const Glib::ValueBase& value)
| Updates an accessible property. More...
void | update_relation (Relation relation, const Glib::ValueBase& value)
| Updates an accessible relation. More...
void | reset_state (State state)
| Resets the accessible state to its default value. More...
void | reset_property (Property property)
| Resets the accessible property to its default value. More...
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value. More...
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given Gtk::Accessible implementation. More...
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given Gtk::Accessible implementation. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable&& src) noexcept
Buildable& | operator= (Buildable&& src) noexcept
| ~Buildable () noexcept override
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object. More...
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget&& src) noexcept
ConstraintTarget& | operator= (ConstraintTarget&& src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkConstraintTarget* | gobj () const
| Provides access to the underlying C GObject. More...
Public Member Functions inherited from Gtk::ShortcutManager
| ShortcutManager (ShortcutManager&& src) noexcept
ShortcutManager& | operator= (ShortcutManager&& src) noexcept
| ~ShortcutManager () noexcept override
GtkShortcutManager* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkShortcutManager* | gobj () const
| Provides access to the underlying C GObject. More...
Public Member Functions inherited from Gtk::Native
| Native (Native&& src) noexcept
Native& | operator= (Native&& src) noexcept
| ~Native () noexcept override
GtkNative* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkNative* | gobj () const
| Provides access to the underlying C GObject. More...
void | realize ()
| Realizes a Gtk::Native. More...
void | unrealize ()
| Unrealizes a Gtk::Native. More...
Glib::RefPtr< Gdk::Surface > | get_surface ()
| Returns the surface of this Gtk::Native. More...
Glib::RefPtr< const Gdk::Surface > | get_surface () const
| Returns the surface of this Gtk::Native. More...
void | get_surface_transform (double& x, double& y)
| Retrieves the surface transform of self. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::ShortcutManager
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Native
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Native* | get_for_surface (const Glib::RefPtr< const Gdk::Surface >& surface)
| Finds the GtkNative associated with the surface. More...

## Protected Member Functions
virtual void | on_closed ()
| This is a default handler for the signal signal_closed(). More...
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int& minimum, int& natural, int& minimum_baseline, int& natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget* child)
| Sets the focused child of widget. More...
virtual void | compute_expand_vfunc (bool& hexpand_p, bool& vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot >& snapshot)
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | realize_if_needed ()
void | set_focus_child (Widget& child)
| Set child as the current focus child of widget. More...
void | unset_focus_child ()
| Unsets the focus child of the widget. More...
Widget* | get_focus_child ()
| Returns the current focus child of widget. More...
const Widget* | get_focus_child () const
| Returns the current focus child of widget. More...
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip >& tooltip)
| This is a default handler for the signal signal_query_tooltip(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Gtk::ShortcutManager
| ShortcutManager ()
| You should derive from this class to use it. More...
virtual void | add_controller_vfunc (const Glib::RefPtr< ShortcutController >& controller)
virtual void | remove_controller_vfunc (const Glib::RefPtr< ShortcutController >& controller)
Protected Member Functions inherited from Gtk::Native
| Native ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Gtk::Popover* | wrap (GtkPopover* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::ShortcutManager
Glib::RefPtr< Gtk::ShortcutManager > | wrap (GtkShortcutManager* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Native
Glib::RefPtr< Gtk::Native > | wrap (GtkNative* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock >&)>
| Callback type for adding a function to update animations. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from Gtk::Accessible
enum | Role { Role::ALERT, Role::ALERT_DIALOG, Role::BANNER, Role::BUTTON, Role::CAPTION, Role::CELL, Role::CHECKBOX, Role::COLUMN_HEADER, Role::COMBO_BOX, Role::COMMAND, Role::COMPOSITE, Role::DIALOG, Role::DOCUMENT, Role::FEED, Role::FORM, Role::GENERIC, Role::GRID, Role::GRID_CELL, Role::GROUP, Role::HEADING, Role::IMG, Role::INPUT, Role::LABEL, Role::LANDMARK, Role::LEGEND, Role::LINK, Role::LIST, Role::LIST_BOX, Role::LIST_ITEM, Role::LOG, Role::MAIN, Role::MARQUEE, Role::MATH, Role::METER, Role::MENU, Role::MENU_BAR, Role::MENU_ITEM, Role::MENU_ITEM_CHECKBOX, Role::MENU_ITEM_RADIO, Role::NAVIGATION, Role::NONE, Role::NOTE, Role::OPTION, Role::PRESENTATION, Role::PROGRESS_BAR, Role::RADIO, Role::RADIO_GROUP, Role::RANGE, Role::REGION, Role::ROW, Role::ROW_GROUP, Role::ROW_HEADER, Role::SCROLLBAR, Role::SEARCH, Role::SEARCH_BOX, Role::SECTION, Role::SECTION_HEAD, Role::SELECT, Role::SEPARATOR, Role::SLIDER, Role::SPIN_BUTTON, Role::STATUS, Role::STRUCTURE, Role::SWITCH, Role::TAB, Role::TABLE, Role::TAB_LIST, Role::TAB_PANEL, Role::TEXT_BOX, Role::TIME, Role::TIMER, Role::TOOLBAR, Role::TOOLTIP, Role::TREE, Role::TREE_GRID, Role::TREE_ITEM, Role::WIDGET, Role::WINDOW }
| The accessible role for a Gtk::Accessible implementation. More...
enum | State { State::BUSY, State::CHECKED, State::DISABLED, State::EXPANDED, State::HIDDEN, State::INVALID, State::PRESSED, State::SELECTED }
| The possible accessible states of a Gtk::Accessible. More...
enum | Property { Property::AUTOCOMPLETE, Property::DESCRIPTION, Property::HAS_POPUP, Property::KEY_SHORTCUTS, Property::LABEL, Property::LEVEL, Property::MODAL, Property::MULTI_LINE, Property::MULTI_SELECTABLE, Property::ORIENTATION, Property::PLACEHOLDER, Property::READ_ONLY, Property::REQUIRED, Property::ROLE_DESCRIPTION, Property::SORT, Property::VALUE_MAX, Property::VALUE_MIN, Property::VALUE_NOW, Property::VALUE_TEXT }
| The possible accessible properties of a Gtk::Accessible. More...
enum | Relation { Relation::ACTIVE_DESCENDANT, Relation::COL_COUNT, Relation::COL_INDEX, Relation::COL_INDEX_TEXT, Relation::COL_SPAN, Relation::CONTROLS, Relation::DESCRIBED_BY, Relation::DETAILS, Relation::ERROR_MESSAGE, Relation::FLOW_TO, Relation::LABELLED_BY, Relation::OWNS, Relation::POS_IN_SET, Relation::ROW_COUNT, Relation::ROW_INDEX, Relation::ROW_INDEX_TEXT, Relation::ROW_SPAN, Relation::SET_SIZE }
| The possible accessible relations of a Gtk::Accessible. More...

## Detailed Description

Context dependent bubbles.

Gtk::Popover is a bubble-like context window, primarily meant to provide context-dependent information or options. Popovers are attached to a widget, set with Gtk::Widget::set_parent(). By default they will point to the whole widget area, although this behavior can be changed through Gtk::Popover::set_pointing_to().

The position of a popover relative to the widget it is attached to can also be changed through Gtk::Popover::set_position().

By default, Gtk::Popover performs a GTK grab, in order to ensure input events get redirected to it while it is shown, and also so the popover is dismissed in the expected situations (clicks outside the popover, or the Esc key being pressed). If no such modal behavior is desired on a popover, Gtk::Popover::set_autohide() may be called on it to tweak its behavior.

Since gtkmm 3.12:

## Constructor & Destructor Documentation

Gtk::Popover::Popover | ( | Popover&& | src | ) |
| noexcept

Gtk::Popover::Popover | ( | const Popover& |  | ) |
| delete

Gtk::Popover::~Popover | ( |  | ) |
| overridenoexcept

Gtk::Popover::Popover | ( |  | ) |

## Member Function Documentation

bool Gtk::Popover::get_autohide | ( |  | ) | const

Returns whether the popover is modal.

See set_autohide() for the implications of this.

Returns
  #`true` if popover is modal.

bool Gtk::Popover::get_cascade_popdown | ( |  | ) | const

Returns whether the popover will close after a modal child is closed.

Returns
  #`true` if popover will close after a modal child.

Widget* Gtk::Popover::get_child | ( |  | ) |

Gets the child widget of popover.

Returns
  The child widget of popover.

const Widget* Gtk::Popover::get_child | ( |  | ) | const

Gets the child widget of popover.

Returns
  The child widget of popover.

bool Gtk::Popover::get_has_arrow | ( |  | ) | const

Gets whether this popover is showing an arrow pointing at the widget that it is relative to.

Returns
  Whether the popover has an arrow.

bool Gtk::Popover::get_mnemonics_visible | ( |  | ) | const

Gets the value of the Gtk::Popover::property_mnemonics_visible() property.

Returns
  `true` if mnemonics are supposed to be visible in this popover.

void Gtk::Popover::get_offset | ( | int & | x_offset,
|  | int & | y_offset
| ) |  | const

Gets the offset previous set with set_offset().

Parameters

  x_offset | A location for the x_offset.
  y_offset | A location for the y_offset.

bool Gtk::Popover::get_pointing_to | ( | Gdk::Rectangle& | rect | ) | const

If a rectangle to point to has been set, this function will return `true` and fill in rect with such rectangle, otherwise it will return `false` and fill in rect with the attached widget coordinates.

Parameters

  rect | Location to store the rectangle.

Returns
  `true` if a rectangle to point to was set.

PositionType Gtk::Popover::get_position | ( |  | ) | const

Returns the preferred position of popover.

Returns
  The preferred position.

static GType Gtk::Popover::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GtkPopover* Gtk::Popover::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GtkPopover* Gtk::Popover::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

virtual void Gtk::Popover::on_closed | ( |  | ) |
| protectedvirtual

This is a default handler for the signal signal_closed().

Popover& Gtk::Popover::operator= | ( | Popover&& | src | ) |
| noexcept

Popover& Gtk::Popover::operator= | ( | const Popover& |  | ) |
| delete

void Gtk::Popover::popdown | ( |  | ) |

Pops popover down.This is different than a Gtk::Widget::hide() call in that it shows the popover with a transition.

If you want to hide the popover without a transition, use Gtk::Widget::hide().

void Gtk::Popover::popup | ( |  | ) |

Pops popover up.

This is different than a Gtk::Widget::show() call in that it shows the popover with a transition. If you want to show the popover without a transition, use Gtk::Widget::show().

void Gtk::Popover::present | ( |  | ) |

Presents the popover to the user.

Glib::PropertyProxy< bool > Gtk::Popover::property_autohide | ( |  | ) |

Whether to dismiss the popover on outside clicks.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Popover::property_autohide | ( |  | ) | const

Whether to dismiss the popover on outside clicks.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Popover::property_cascade_popdown | ( |  | ) |

Whether the popover pops down after a child popover.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Popover::property_cascade_popdown | ( |  | ) | const

Whether the popover pops down after a child popover.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Widget* > Gtk::Popover::property_child | ( |  | ) |

The child widget.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Widget* > Gtk::Popover::property_child | ( |  | ) | const

The child widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Widget* > Gtk::Popover::property_default_widget | ( |  | ) |

The default widget.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Widget* > Gtk::Popover::property_default_widget | ( |  | ) | const

The default widget.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Popover::property_has_arrow | ( |  | ) |

Whether to draw an arrow.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Popover::property_has_arrow | ( |  | ) | const

Whether to draw an arrow.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::Popover::property_mnemonics_visible | ( |  | ) |

Whether mnemonics are currently visible in this popover.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::Popover::property_mnemonics_visible | ( |  | ) | const

Whether mnemonics are currently visible in this popover.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Gdk::Rectangle > Gtk::Popover::property_pointing_to | ( |  | ) |

Rectangle the bubble window points to.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Gdk::Rectangle > Gtk::Popover::property_pointing_to | ( |  | ) | const

Rectangle the bubble window points to.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< PositionType > Gtk::Popover::property_position | ( |  | ) |

Position to place the bubble window.

Default value: Gtk::PositionType::BOTTOM

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< PositionType > Gtk::Popover::property_position | ( |  | ) | const

Position to place the bubble window.

Default value: Gtk::PositionType::BOTTOM

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::Popover::set_autohide | ( | bool | autohide = `true` | ) |

Sets whether popover is modal.

A modal popover will grab the keyboard focus on it when being displayed. Clicking outside the popover area or pressing Esc will dismiss the popover.

Called this function on an already showing popup with a new autohide value different from the current one, will cause the popup to be hidden.

Parameters

  autohide | #`true` to dismiss the popover on outside clicks.

void Gtk::Popover::set_cascade_popdown | ( | bool | cascade_popdown = `true` | ) |

If cascade_popdown is #`true`, the popover will be closed when a child modal popover is closed.

If #`false`, popover will stay visible.

Parameters

  cascade_popdown | #`true` if the popover should follow a child closing.

void Gtk::Popover::set_child | ( | Widget& | child | ) |

Sets the child widget of popover.

Parameters

  child | The child widget.

void Gtk::Popover::set_default_widget | ( | Widget& | widget | ) |

The default widget is the widget that’s activated when the user presses Enter in a dialog (for example).

This function sets or unsets the default widget for a Gtk::Popover.

Parameters

  widget | A child widget of popover to set as the default, or `nullptr` to unset the default widget for the popover.

void Gtk::Popover::set_has_arrow | ( | bool | has_arrow = `true` | ) |

Sets whether this popover should draw an arrow pointing at the widget it is relative to.

Parameters

  has_arrow | `true` to draw an arrow.

void Gtk::Popover::set_mnemonics_visible | ( | bool | mnemonics_visible = `true` | ) |

Sets the Gtk::Popover::property_mnemonics_visible() property.

Parameters

  mnemonics_visible | The new value.

void Gtk::Popover::set_offset | ( | int | x_offset,
|  | int | y_offset
| ) |  |

Sets the offset to use when calculating the position of the popover.

These values are used when preparing the Gtk::PopupLayout for positioning the popover.

Parameters

  x_offset | The x offset to adjust the position by.
  y_offset | The y offset to adjust the position by.

void Gtk::Popover::set_pointing_to | ( | const Gdk::Rectangle& | rect | ) |

Sets the rectangle that popover will point to, in the coordinate space of the popover parent.

Parameters

  rect | Rectangle to point to.

void Gtk::Popover::set_position | ( | PositionType | position = `PositionType::TOP` | ) |

Sets the preferred position for popover to appear.

If the popover is currently visible, it will be immediately updated.

This preference will be respected where possible, although on lack of space (eg. if close to the window edges), the Gtk::Popover may choose to appear on the opposite side

Parameters

  position | Preferred popover position.

Glib::SignalProxy<void()> Gtk::Popover::signal_closed | ( |  | ) |

Slot Prototype:
  `void on_my_closed()`

Flags: Run Last

The signal_closed() signal is emitted when the popover is closed.

void Gtk::Popover::unset_child | ( |  | ) |

## Friends And Related Function Documentation

Gtk::Popover* wrap | ( | GtkPopover * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.